import lxml.etree as et
import operator
import pandas as pd

def execute():
    dict_to_save = {}
    countries = ['szwecja'] #['szwecja', 'dania', 'finlandia']
    for country in countries:
        list_to_save = []
        xml = f'download/vida_{country}.xml'
        print(xml)
        for event, elem in et.iterparse(xml):
            ean = 0
            if elem.tag == "o":
                try:
                    for attr in elem.find('attrs').findall('a'):
                        if attr.attrib['name'] == 'EAN':
                            ean = int(attr.text)
                    if int(elem.attrib['stock']) > 0:
                            if ean in dict_to_save.keys():
                                dict_to_save[ean]['price_feed_'+country] = float(elem.attrib['price'])
                                dict_to_save[ean]['stock_feed_'+country] = elem.attrib['stock']
                                dict_to_save[ean]['sku_feed_'+country] = str(elem.attrib['id'])
                            else:
                                dict_to_save[ean] = {
                                    'ean': ean,
                                    'price_feed_'+country: float(elem.attrib['price']),
                                    'stock_feed_'+country: elem.attrib['stock'],
                                    'sku_feed_'+country: str(elem.attrib['id']),
                                }
                except Exception as e:
                    print(e)
                    print('error with item')
    #print(dict_to_save)
    for key in dict_to_save:
        try:
            price_feed_szwecja = dict_to_save[key]['price_feed_szwecja']
            stock_feed_szwecja = dict_to_save[key]['stock_feed_szwecja']
            sku_feed_szwecja = dict_to_save[key]['sku_feed_szwecja']
        except:
            price_feed_szwecja = '0'
            stock_feed_szwecja = '0'
            sku_feed_szwecja = '0'
        """try:
            price_feed_dania = dict_to_save[key]['price_feed_dania']
            stock_feed_dania = dict_to_save[key]['stock_feed_dania']
            sku_feed_dania = dict_to_save[key]['sku_feed_dania']
        except:
            price_feed_dania = '0'
            stock_feed_dania = '0'
            sku_feed_dania = '0'
        try:
            price_feed_finlandia = dict_to_save[key]['price_feed_finlandia']
            stock_feed_finlandia = dict_to_save[key]['stock_feed_finlandia']
            sku_feed_finlandia = dict_to_save[key]['sku_feed_finlandia']
        except:
            price_feed_finlandia = '0'
            stock_feed_finlandia = '0'
            sku_feed_finlandia = '0'"""
        list_to_save.append({
            'price_feed_szwecja': price_feed_szwecja,
            'stock_feed_szwecja': stock_feed_szwecja,
            'sku_feed_szwecja': sku_feed_szwecja,
            })
        """'price_feed_dania': price_feed_dania,
            'stock_feed_dania': stock_feed_dania,
            'sku_feed_dania': sku_feed_dania,
            'price_feed_finlandia': price_feed_finlandia,
            'stock_feed_finlandia': stock_feed_finlandia,
            'sku_feed_finlandia': sku_feed_finlandia,
            })"""
    newlist = sorted(list_to_save, key=operator.itemgetter('sku_feed_szwecja'))
    pd.DataFrame(newlist).to_csv('download/all_vida.csv', sep = ';', encoding = 'utf-8', index = False, mode = 'w', header = True)
    
if __name__ == "__main__":
    execute()